<!doctype html>
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
    integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

  <title>Lecturer - Attendance</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <a class="navbar-brand" href="/lecturer">UTMSmart</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
      aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item">
          <a class="nav-link" href="/lecturer">Home <span class="sr-only">(current)</span></a>
        </li>
        <li class="nav-item active">
          <a class="nav-link" href="/lecturer/attendance">Class Attendance</a>
        </li>
      </ul>
      <ul class="navbar-nav">
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle  mr-5" href="#" id="navbarDropdown" role="button" data-toggle="dropdown"
            aria-haspopup="true" aria-expanded="false">
            Welcome Alex
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item" href="#">Manage Account</a>
            <div class="dropdown-divider"></div>
            <a class="dropdown-item" href="#">Log Out</a>
          </div>
        </li>
      </ul>
    </div>
  </nav>
  <br>
  <div class="container">
    <h2>List of Active Class</h2>
    <ul class="list-group" id="currentCourse"></ul>

    <hr>
    <h2>Recent Attendance</h2>
    <ul class="list-group" id="recentAttendance"></ul>
  </div>
  <!-- Optional JavaScript -->
  <!-- jQuery first, then Popper.js, then Bootstrap JS -->
  <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>

  <script>
    document.addEventListener("DOMContentLoaded", function (event) {
      const ul = document.getElementById('currentCourse');

      // populate active class
      var xhr = new XMLHttpRequest();
      xhr.open('GET', '/api/lecturer/getCurrentCourse');
      xhr.onload = function () {
        if (xhr.status === 200) {
          var response = JSON.parse(xhr.responseText)
          response.forEach(element => {
            const li = document.createElement('li');
            li.classList.add('list-group-item')
            li.innerHTML = `
            <a href="#">${element.Code} - 0${element.Section} ${element.Name}</a><button onclick="start('${element._id}')" class="btn btn-secondary float-right">Start Attendance</button>`;
            li.id = element._id;
            ul.appendChild(li);
          });
        }
      };
      xhr.send();

      // populate recent attendance
      const ul2 = document.getElementById('recentAttendance');
      var xhr2 = new XMLHttpRequest();
      xhr2.open('GET', '/api/lecturer/attendance');
      xhr2.onload = function () {
        if (xhr2.status === 200) {
          var response = JSON.parse(xhr2.responseText)
          response.forEach(element => {
            const d = new Date(element.TimeStart).toLocaleString();
            const d2 = new Date(element.TimeStop).toLocaleString().split(',')[1];

            const li = document.createElement('li')
            li.classList.add('list-group-item')
            li.innerHTML = `
            <a href="/attendanceList/${element._id}">${element.CurrentCourse.Code} - 0${element.CurrentCourse.Section} ${element.CurrentCourse.Name}</a>
            <a href="/attendanceScan/${element.key}" class="float-right">Open QR</a> <br>${d} - ${d2}`;
            ul2.prepend(li)
          });
        }
      };
      xhr2.send();
    });

    function start(courseID) {
      const ul2 = document.getElementById('recentAttendance');

      var xhr = new XMLHttpRequest();
      xhr.open('POST', '/api/lecturer/startAttendance');
      xhr.setRequestHeader('Content-Type', 'application/json');
      xhr.onload = function () {
        if (xhr.status === 200) {
          console.log(xhr.responseText);

          var result = JSON.parse(xhr.responseText);

          const d = new Date(result.TimeStart).toLocaleString();
          const d2 = new Date(result.TimeStop).toLocaleString().split(',')[1];

          // here can do something with the result
          const li = document.createElement('li')
          li.classList.add('list-group-item')
          li.style.backgroundColor = 'lightpink';
          li.innerHTML = `
          ${result.CurrentCourse.Code} - 0${result.CurrentCourse.Section} ${result.CurrentCourse.Name} 
          <a href="/attendanceScan/${result.key}" class="float-right">Open QR</a> <br>${d} - ${d2}`;
          ul2.prepend(li)
          // redirect to another page on success
        }
      };
      xhr.send(JSON.stringify({ courseID }));
    }
  </script>
</body>

</html>
